local T, C, L, _ = unpack(select(2, ...))
if C.skins.blizzard_frames ~= true or IsAddOnLoaded("QuestLogEx") then return end -- incomplete

----------------------------------------------------------------------------------------
--	QuestLog skin
----------------------------------------------------------------------------------------
local function LoadSkin()
	local QuestStrip = {
		"QuestLogFrame",
		"QuestLogCount",
		"QuestLogQuestCount",
		"EmptyQuestLogFrame"
	}

	for i = 1, getn(QuestStrip) do
		local object = _G[QuestStrip[i]]
		if object then
			object:StripTextures(true)
		end
	end

	QuestLogFrame:SetAttribute("UIPanelLayout-width", T.Scale(685))
	QuestLogFrame:SetAttribute("UIPanelLayout-height", T.Scale(490))
	QuestLogFrame:SetSize(685, 490)
	QuestLogFrame:CreateBackdrop("Transparent")
	QuestLogFrame.backdrop:SetPoint("TOPLEFT", 10, -12)
	QuestLogFrame.backdrop:SetPoint("BOTTOMRIGHT", -1, 8)

	QuestLogFrame:DisableDrawLayer("BACKGROUND")

	QuestLogTitleText:ClearAllPoints()
	QuestLogTitleText:SetPoint("TOP", QuestLogFrame.backdrop, "TOP", 0, -6)

	T.SkinCloseButton(QuestLogFrameCloseButton)
	QuestLogFrameCloseButton:ClearAllPoints()
	QuestLogFrameCloseButton:SetPoint("TOPRIGHT", -5, -16)

	QuestLogListScrollFrame:StripTextures()
	QuestLogListScrollFrame:CreateBackdrop("Default", true)
	QuestLogListScrollFrame.backdrop:SetPoint("TOPLEFT", -4, 4)
	QuestLogListScrollFrame:SetSize(301, 373)

	QuestLogDetailScrollFrame:StripTextures()
	QuestLogDetailScrollFrame:CreateBackdrop("Default", true)
	QuestLogDetailScrollFrame.backdrop:SetPoint("TOPLEFT", -4, 2)
	QuestLogDetailScrollFrame:SetSize(300, 375)
	QuestLogDetailScrollFrame:ClearAllPoints()
	QuestLogDetailScrollFrame:SetPoint("TOPRIGHT", QuestLogFrame, -32, -73)

	QuestLogDetailScrollFrame:DisableDrawLayer("BACKGROUND")

	QuestLogNoQuestsText:ClearAllPoints()
	QuestLogNoQuestsText:SetPoint("CENTER", EmptyQuestLogFrame, "CENTER", -45, 65)

	QuestLogFrameAbandonButton:SetPoint("BOTTOMLEFT", 15, 15)
	QuestLogFrameAbandonButton:SetWidth(99)
	QuestLogFrameAbandonButton:SetText(ABANDON_QUEST)

	QuestFramePushQuestButton:ClearAllPoints()
	QuestFramePushQuestButton:SetPoint("LEFT", QuestLogFrameAbandonButton, "RIGHT", 2, 0)
	QuestFramePushQuestButton:SetWidth(99)
	QuestFramePushQuestButton:SetText(SHARE_QUEST)

	QuestLogFrameTrackButton:ClearAllPoints()
	QuestLogFrameTrackButton:SetPoint("LEFT", QuestFramePushQuestButton, "RIGHT", 2, 0)
	QuestLogFrameTrackButton:SetWidth(99)
	QuestLogFrameTrackButton:SetText(TRACK_QUEST)

	T.SkinScrollBar(QuestLogDetailScrollFrameScrollBar)
	T.SkinScrollBar(QuestLogListScrollFrameScrollBar)
	QuestLogListScrollFrameScrollBar:SetPoint("TOPLEFT", QuestLogListScrollFrame, "TOPRIGHT", 5, -16)

	QuestLogCount:ClearAllPoints()
	QuestLogCount:SetPoint("TOPRIGHT", QuestLogFrame, "TOPRIGHT", -590, 0)

	local QuestButtons = {
		"QuestLogFrameAbandonButton",
		"QuestLogFrameTrackButton",
		"QuestFramePushQuestButton",
		"QuestLogFrameCancelButton",
	}

	for i = 1, getn(QuestButtons) do
		local object = _G[QuestButtons[i]]
		if object then
			object:StripTextures()
			object:SkinButton()
		end
	end

	local function QuestQualityColors(frame, text, quality, link)
		if link and not quality then
			quality = select(3, GetItemInfo(link))
		end

		if T.BCC and frame then
			Mixin(frame, BackdropTemplateMixin) -- 9.0 to set backdrop
		end

		if quality then
			if frame then
				frame:SetBackdropBorderColor(GetItemQualityColor(quality))
			end
			text:SetTextColor(GetItemQualityColor(quality))
		else
			if frame then
				frame:SetBackdropBorderColor(unpack(C.media.backdrop_color))
			end
			text:SetTextColor(1, 1, 1)
		end
	end

	hooksecurefunc("QuestRewardItem_OnClick", function()
		QuestRewardItemHighlight:ClearAllPoints();
		QuestRewardItemHighlight:SetOutside(this:GetName().."IconTexture")
		_G[this:GetName().."Name"]:SetTextColor(1, 1, 0)

		for i = 1, MAX_NUM_ITEMS do
			local questItem = _G["QuestRewardItem"..i]
			local questName = _G["QuestRewardItem"..i.."Name"]
			local link = questItem.type and GetQuestItemLink(questItem.type, questItem:GetID())

			if questItem ~= this then
				QuestQualityColors(nil, questName, nil, link)
			end
		end
	end)

	for i = 1, 20 do
		local questLogTitle = _G["QuestLogListScrollFrameButton"..i]
		local highlight = _G["QuestLogListScrollFrameButton"..i.."Highlight"]
		highlight:SetTexture()
		hooksecurefunc(questLogTitle, "SetNormalTexture", function(self, texture)
			local tex = self:GetNormalTexture()

			if strfind(texture, 'MinusButton') then
				tex:SetTexture(C.media.Minus)
			elseif strfind(texture, 'PlusButton') then
				tex:SetTexture(C.media.Plus)
			else
				tex:SetTexture()
			end
		end)
	end

	local function colourObjectivesText()
		if not QuestInfoFrame.questLog then return end

		local objectivesTable = QuestInfoObjectivesFrame.Objectives
		local numVisibleObjectives = 0

		for i = 1, GetNumQuestLeaderBoards() do
			local _, type, finished = GetQuestLogLeaderBoard(i)

			if (type ~= "spell" and type ~= "log" and numVisibleObjectives < MAX_OBJECTIVES) then
				numVisibleObjectives = numVisibleObjectives + 1
				local objective = objectivesTable[numVisibleObjectives]

				if objective then
					if finished then
						objective:SetTextColor(.9, .9, .9)
					else
						objective:SetTextColor(1, 1, 1)
					end
				end
			end
		end
	end

	hooksecurefunc("QuestInfo_Display", function()
		colourObjectivesText()

        local rewardsFrame = QuestInfoFrame.rewardsFrame
        local isQuestLog = QuestInfoFrame.questLog ~= nil
		local numSpellRewards = isQuestLog and GetNumQuestLogRewardSpells() or GetNumRewardSpells()

		if numSpellRewards > 0 then
			-- Spell Headers
			for spellHeader in rewardsFrame.spellHeaderPool:EnumerateActive() do
				spellHeader:SetVertexColor(1, 1, 1)
			end
		end
	end)

	local function HookTextColor_Yellow(self, r, g, b)
		if r ~= 1 or g ~= .8 or b ~= 0 then
			self:SetTextColor(1, .8, 0)
		end
	end

	local function SetTextColor_Yellow(font)
		font:SetShadowColor(0, 0, 0, 0)
		font:SetTextColor(1, .8, 0)
		hooksecurefunc(font, "SetTextColor", HookTextColor_Yellow)
	end

	local function HookTextColor_White(self, r, g, b)
		if r ~= 1 or g ~= 1 or b ~= 1 then
			self:SetTextColor(1, 1, 1)
		end
	end

	local function SetTextColor_White(font)
		font:SetShadowColor(0, 0, 0)
		font:SetTextColor(1, 1, 1)
		hooksecurefunc(font, "SetTextColor", HookTextColor_White)
	end

		-- Change text colors
	hooksecurefunc(QuestInfoRequiredMoneyText, "SetTextColor", function(self, r)
		if r == 0 then
			self:SetTextColor(.8, .8, .8)
		elseif r == .2 then
			self:SetTextColor(1, 1, 1)
		end
	end)

	local yellowish = {
		QuestInfoTitleHeader,
		QuestInfoDescriptionHeader,
		QuestInfoObjectivesHeader,
		QuestInfoRewardsFrame.Header,
		QuestInfoQuestType,
	}
	for _, font in pairs(yellowish) do
		SetTextColor_Yellow(font)
	end

	local whitish = {
		QuestInfoDescriptionText,
		QuestInfoObjectivesText,
		QuestInfoGroupSize,
		QuestInfoRewardText,
		QuestInfoSpellObjectiveLearnLabel,
		QuestInfoRewardsFrame.ItemChooseText,
		QuestInfoRewardsFrame.ItemReceiveText,
		QuestInfoRewardsFrame.PlayerTitleText,
		QuestInfoRewardsFrame.XPFrame.ReceiveText,
		QuestInfoTalentFrame.ReceiveText,
	}
	for _, font in pairs(whitish) do
		SetTextColor_White(font)
	end
end

table.insert(T.SkinFuncs["ShestakUI"], LoadSkin)